package hdm.mi.growbros.models.plant;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotBlank;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.URL;
//careful! weeks are indexed at 0 -> max value is 51.

@Data
@AllArgsConstructor
@NoArgsConstructor
@Entity
public class Plant {
    @Id
    @GeneratedValue
    private Long id;

    @NotBlank
    private String name;

    private String latinName;

    @Column(columnDefinition = "TEXT")
    private String description;

    @Column(columnDefinition = "TEXT")
    private String origin;

    @Column(columnDefinition = "TEXT")
    private String growingTips;

    @Min(0)
    @Max(51)
    private int plantWeekStart;

    @Min(0)
    @Max(51)
    private int plantWeekEnd;

    @Min(0)
    private int growthDuration;

    @Min(0)
    @Max(51)
    private int harvestWeekStart;

    @Min(0)
    @Max(51)
    private int harvestWeekEnd;

    private GroundType groundType;
    private NutrientDemand nutrientDemand;
    private WaterDemand waterDemand;
    private LightingDemand lightingDemand;

    @URL
    private String imageUrl;
}
